TITLE	CLICK.ASM

COMMENT |

PROGRAM:	CLICK.COM
VERSION:	1.0
RELEASED:	01/17/1992
AUTHOR:		Duane Paulson

PURPOSE:	Amusement: Noisemaker.
		Produces sound every time int 10h is called.

MEMORY
REQUIREMENTS:	TSR. Requires 304 bytes plus size of current environment.

CALL:		CLICK

RETURNS:	nothing

CAVEATS:	Slows system down considerably.
		Not recommended for use while running communications
		 software.

ASSEMBLE:	MASM /Z /W2 CLICK,,CLICK;
LINK:		LINK CLICK;
		EXE2BIN CLICK CLICK.COM

ASSEMBLER:	MASM 5.10A

| end of comment

; --- NUMERICAL EQUATES -----------------------------------------------------
DELAY		EQU	1000
HI_BYTE		EQU	11h
LO_BYTE		EQU	0DCh


; --- CODE SEGMENT DEFINITION -----------------------------------------------
text		SEGMENT	PARA	'CODE'
		ORG	100h
		ASSUME	CS:text, DS:text, SS:text, ES:text

; --- PROGRAM ENTRY POINT ---------------------------------------------------
entry		PROC	NEAR		; program entry point
start:		jmp	SHORT begin	; jump to install routine
entry		ENDP

; --- DATA ITEMS TO BE ADDRESSED BY THE INTERRUPT HANDLER ------------------
old_int_10	LABEL	DWORD		; address of old BIOS video interrupt
old_10_off	DW	?
old_10_seg	DW	?

video_int	PROC	FAR
		ASSUME	CS:text, DS:nothing, SS:nothing, ES:nothing

		pushf				; simulate an interrupt call
		call	old_int_10		;  to BIOS video interrupt

		push	ax			; save registers used
		push	cx
		mov	al,0B6h			; adjust speaker frequency
		out	43h,al
		mov	al,LO_BYTE		; low byte of frequency
		out	42h,al
		mov	al,HI_BYTE		; high byte of frequency
		out	42h,al
		in	al,61h			; turn on speaker
		or	al,3
		out	61h,al
		mov	cx,DELAY
i10loop:	loop	i10loop			; delay loop
		in	al,61h			; turn off speaker
		and	al,0FCh
		out	61h,al

		pop	cx			; restore registers
		pop	ax

		iret				; return from interrupt

video_int	ENDP


;--- RESIDENT CODE ENDS HERE -------------------------------------------------

; --- INSTALLATION CODE ------------------------------------------------------
install		PROC	NEAR			; installs the TSR
		ASSUME	CS:text, DS:text, SS:text, ES:text

begin:		mov	ax,3510h		; get vector for
		int	21h			;  BIOS video interrupt
		mov	old_10_seg,es		;  and save
		mov	old_10_off,bx

		mov	ax,2510h		; replace user timer interrupt
		mov	dx,OFFSET video_int
		int	21h			; with our handler

		mov	ah,9			; print installation message
		mov	dx,OFFSET inst_msg
		int	21h

		mov	ax,OFFSET install	; get number of bytes
						;  in resident code
		shr	ax,1			; divide by 16 to get paragraphs
		shr	ax,1
		shr	ax,1
		shr	ax,1
		inc	ax			; include last paragraph
		mov	dx,ax
		mov	ax,3100h		; terminate and stay resident
		int	21h

install		ENDP

; -- DATA FOR THE INSTALLATION ROUTINE (NOT PRESERVED) ------------------------
inst_msg	DB	"CLICK.COM installed ",254
		DB	" Version 0.1",13,10,'$'

text		ENDS
		END	start
